#ifndef appH
#define appH


#include <limits.h>
#include <list>

//-------  ---------------------------------
#define 	NONUM		UINT_MAX

enum 	TYPE { RECTANG, CHAOS, APEX };
enum	APEX {  		//	 
	NOT_TESTED,    //  
	INSIDE,        //  ( 1 )
	SIDE,          //   ( 2 )
	BORDER,        //      (  2 )
	KNOT,          //   (  3 )
	POLY,          //    (  1 )
	POLY_SIDE,     //      . (  2 )
	POLY_BORDER,   //      (  2 )
	POLY_KNOT,     //      (  3 )
	NOT_POLY,      //       .
	NOT_BORDER,    //    ,  
	NOT_KNOT, 		//    , 
	APEX_ERR,		// 
	APEX_SIZE };

enum    DATA_TYPE { TYPE_NAME,
	SET_POLY, SET_NOT_POLY, INCREASE_INDEX,
	CONVERT_IN, CONVERT_POLY, CONVERT_OUT,
	IF_DO_EXAM, IF_INNER, IF_POLY, IF_DECLINED, IF_NOT_TESTED, IF_CORRECT,
	CHARS, CHARG,
	DATA_SIZE };

//-------  --------------------------------------
typedef struct  { int a,b,c; } Face;  // asi
typedef std::list<Face> FList;        // asi

typedef 	unsigned int APNUM;
typedef	struct 	{ float x, y, z; } VEC3;
struct 	apex { VEC3 v; char fl; };
struct 	Surface { APNUM k_apexs; struct apex * apexs; };
struct 	r_surface { APNUM kx, ky, kz; float * x, * y, * z; char * fl; };

typedef	struct 	{ float x, y; } VEC2;
struct 	sym_matrix { double a11, a22, a33, a12, a13, a23; };
struct 	plane { double A, B, C; VEC3 v0;
		struct sym_matrix a; VEC3 b; double L, zz; };
struct 	apex_list { APNUM k_l, i_l, max_k_l; APNUM * p_l; };
struct 	side_list { APNUM k_l, i_l, max_k_l; APNUM * p_l1, * p_l2; };

//-------   --------------------------
/***  ?!  
//c//       
int	approx (void * surface, short type, float eps);
//c//   (c_...)
int	c_approx (struct Surface * Surface, float eps);
//c//   (r_...)
int	r_approx (struct r_surface * surface, float eps);
//c//  Z- (RECTANG)    (APEX)
void	set_surface (void * surface, short type);
//c//   (RECTANG)   (CHAOS)
void	set_area (short type);
***/

//c//     
APNUM 	form_new (void * old_s, short type, struct Surface * p_new_s);
//APNUM 	c_form_new (struct Surface * old_s, struct Surface * p_new_s);
//APNUM 	c_reduce_surf (struct Surface * surf);
//APNUM 	r_form_new (struct r_surface * old_s, struct Surface * p_new_s);

//c//	 
//int	show_triangulation (struct Surface * Surface);

//c//    ch
//int	ch_pressed (char ch);

//   1      (abc)->(cab)
void   ShiftFace(Face &fc);

#ifdef   ALL

//-------  --------------------------------
//c//  
float	dist2 (VEC2 * v);
//c// 
float	dist (VEC2 * v);
//c//	 
float	scal (VEC2 * v1, VEC2 * v2);
//c//	z-    [v1,v2]
float	vec_z (VEC2 * v1, VEC2 * v2);

//-------   ---------------------------
//c//	  
int	start_poly (APNUM i1, APNUM i2, struct plane * pl);
//c//	    
float	sq_deviation (APNUM i, struct plane * pl);

//-------   ------------------------
//c// 
int	get_dat (int fl, int dat);
//c//    
int	convert (int typ);

//c//	     ?
#define 	if_do_exam(i) 		get_dat (get_fl (i), IF_DO_EXAM)
//c//	      ?
#define 	if_inner(i) 		get_dat (get_fl (i), IF_INNER)
//c//	     ?
#define 	if_poly(i) 			get_dat (get_fl (i), IF_POLY)
//c//	      ?
#define 	if_declined(i) 	get_dat (get_fl (i), IF_DECLINED)
//c//	    ?
#define 	if_not_tested(i) 	get_dat (get_fl (i), IF_NOT_TESTED)

//c//	    
#define 	set_poly(i) 		set_fl (i, get_dat (get_fl (i), SET_POLY) )
//c//	     
#define 	set_not_poly(i) 	set_fl (i, get_dat (get_fl (i), SET_NOT_POLY) )
//c//   ,    
#define 	increase_index(i)	set_fl (i, get_dat (get_fl (i), INCREASE_INDEX) )

//c//     
#define 	convert_in()		convert (CONVERT_IN)
//c//	   ,  
#define 	convert_poly()		convert (CONVERT_POLY)
//c//     
#define 	convert_out()		convert (CONVERT_OUT)

//-------   (.  ) ------
//c//	2- vj - vi
VEC2	*	c_vec (APNUM i, APNUM j, VEC2 * v);
VEC2	*	r_vec (APNUM i, APNUM j, VEC2 * v);
//c// 3- vj - vi
VEC3	*	c_vec3 (APNUM i, APNUM j, VEC3 * v3);
VEC3	*	r_vec3 (APNUM i, APNUM j, VEC3 * v3);
//c// 3- vi
VEC3	*	c_vec3_1 (APNUM i, VEC3 * v3);
VEC3	*	r_vec3_1 (APNUM i, VEC3 * v3);

//c//   
int	c_get_fl (APNUM i);
int	r_get_fl (APNUM i);
//c//   
int	c_set_fl (APNUM i, char fl);
int	r_set_fl (APNUM i, char fl);

//-------   -----------------------
//c// 1- 
APNUM	c_first_neighbour (APNUM i);
APNUM	r_first_neighbour (APNUM i);
//c//  
APNUM	c_next_neighbour (void);
APNUM	r_next_neighbour (void);

//c//	  
APNUM	c_nearest_neighbour (APNUM i1);
APNUM	r_nearest_neighbour (APNUM i1);				//?  ?
//c//	   () 
APNUM	r_left_triangle (APNUM i1, APNUM i2);     //?  ?
APNUM	c_left_triangle (APNUM i1, APNUM i2);

APNUM	c_right_triangle (APNUM i1, APNUM i2);

//-------   ----------------
//c//  Z- (RECTANG)    (APEX)
void	set_surface (void * surface, short type);
//c//   (RECTANG)   (CHAOS)
void	set_area (short type);

//-------   -------------------------
//c//    
int	push_apex (APNUM i);
//c//	  
int	pop_apex (APNUM * i);

//c//    
int	push_side (APNUM i1, APNUM i2);
//c//	  
int	pop_side (APNUM * i1, APNUM * i2);
void clear_sides(void);

//-------  ------------------------------------
//c//	      
int	alloc_lists_a (APNUM k_max);
int	alloc_lists_s (APNUM k_max);
//c//	 
void	free_lists (void);

//-------  ------------------------------
//c//	      
int	approx (void * surface, short type, float eps);
//c//   (c_...)
int	c_approx (struct Surface * Surface, float eps);
//c//   (r_...)
int	r_approx (struct r_surface * surface, float eps);
//c//    (..._a)
int	approx_a (float eps);
//c//    (..._s)
int	approx_s (float eps);

//-------  ------------------------------------
//c//     
APNUM 	c_form_new (struct Surface * old_s, struct Surface * p_new_s);
APNUM 	c_reduce_surf (struct Surface * surf);
APNUM 	r_form_new (struct r_surface * old_s, struct Surface * p_new_s);

//c//	 
int	show_triangulation (struct Surface * Surface);

//c//	  
int	r_make_contour (struct apex_list * contour);
int	c_make_contour (struct apex_list * contour);

//c//    ch
//int	ch_pressed (char ch);

//   1      (abc)->(cab)
void   ShiftFace(Face &fc);

//-------  --------------------------------
//c// 
static	int		k_apexs;             	//  
static   struct 	r_surface 	r_surf;    	//  
static   struct 	Surface 	c_surf;   	//  
//c// . 
static   struct 	apex_list 	apexs;		//  
static   struct 	side_list 	sides;		//  
//c//   . i
static	APNUM 		nb_for_i=NONUM, first_nb_for_i=NONUM, cur_nb_for_i=NONUM;
static	int 		cur_nb_type=-1;

//c// 
//c// 
static	VEC2	*	(* vec) (APNUM i, APNUM j, VEC2 * v); 	// 2- vj-vi
static	VEC3	*	(* vec3) (APNUM i, APNUM j, VEC3 * v3); // 3- vj-vi
static	VEC3	*	(* vec3_1) (APNUM i, VEC3 * v3);      // 3- vi
//c// 
static	int	(* get_fl) (APNUM i);                  	//  
static	int	(* set_fl) (APNUM i, char fl);				//  
//c//   
static	APNUM	(* first_neighbour) (APNUM i1);				// 1- 
static	APNUM	(* next_neighbour) (void);			  		// . 
//c//   
static	APNUM	(* nearest_neighbour) (APNUM i1) = c_nearest_neighbour;	// . 
static	APNUM	(* left_triangle) (APNUM i1, APNUM i2) = c_left_triangle; //  -

static	APNUM	(* right_triangle) (APNUM i1, APNUM i2) = c_right_triangle;//  -

static 	int	(* make_contour) (struct apex_list * contour);	//  

enum	{ ESC=0x1B };

//---------------------------------------------------
#endif

#endif   // appH
