
//       ,      C++ BUILDER
//         Material  D3DTexture
//---------------------------------------------------------------------------
#ifndef d3matrlH
#define d3matrlH

#include "sc_material.h"
#include "sc_tex.h"

#define DEFAULT_TXTRFILE "deftxtr256.bmp"
//---------------------------------------------------------------------------
class PACKAGE TD3Texture: public D3DTexture
{

private:
    AnsiString FBitmapFile;
    int FSize;
    RECT FRect;
    Graphics::TBitmap * FBitmap;
    void __fastcall SetBitmapFile(AnsiString value);
public:
    __fastcall TD3Texture(AnsiString BitmapFile = DEFAULT_TXTRFILE);
    __property AnsiString BitmapFile  = { read = FBitmapFile, write = SetBitmapFile };
    __property int Size  = { read = FSize };
    __property RECT Rect  = { read = FRect, write = FRect };
    __property D3DTEXTUREHANDLE Handle  = { read = GetHandle, write = SetHandle };
    __property Graphics::TBitmap * Bitmap  = { read = FBitmap, write = FBitmap };
};
//---------------------------------------------------------------------------
class PACKAGE TD3Material: public Material
{
private:
    TD3Texture FTexture;
    TColor FDiffuse;
    TColor FAmbient;
    float FAlpha;
    TColor FEmissive;
    TColor FSpecular;
    float FPower;
    void __fastcall SetDiffuse(TColor value);
    void __fastcall SetAmbient(TColor value);
    void __fastcall SetAlpha(float value);
    void __fastcall SetEmissive(TColor value);
    void __fastcall SetSpecular(TColor value);
    void __fastcall SetPower(float value);
public:
    __fastcall TD3Material::TD3Material(TColor Diff = clGray, TColor Amb = clGray,
		     TColor  Spec= clLtGray, float Pow=5., TColor  Emis= clBlack);
    __property TD3Texture Texture  = { read = FTexture, write = FTexture };
    __property TColor Diffuse  = { read = FDiffuse, write = SetDiffuse };
    __property TColor Ambient  = { read = FAmbient, write = SetAmbient };
    __property float Alpha  = { read = FAlpha, write = SetAlpha };
    __property TColor Emissive  = { read = FEmissive, write = SetEmissive };
    __property TColor Specular  = { read = FSpecular, write = SetSpecular };
    __property float Power  = { read = FPower, write = SetPower };
};
//---------------------------------------------------------------------------
#endif

