//---------------------------------------------------------------------------
#ifndef lightH
#define lightH
//---------------------------------------------------------------------------

#include "object.h"

enum LIGHT {    ltAmbient=D3DRMLIGHT_AMBIENT, ltPoint=D3DRMLIGHT_POINT,
                ltSpot=D3DRMLIGHT_SPOT, ltDirectional=D3DRMLIGHT_DIRECTIONAL,
                ltParallelPoint=D3DRMLIGHT_PARALLELPOINT };

//---------------------------------------------------------------------------

#pragma pack(push, 4)
class PACKAGE TD3Light: public TD3Visual
{
private:
    TColor FColor;
    LIGHT FType;
    float FBrightness;
    float FHotSpot;
    float FSpot;
    void __fastcall SetColor(TColor value);
    void __fastcall SetType(LIGHT value);
    void __fastcall SetBrightness(float value);
    void __fastcall SetUmbra(float value);
    void __fastcall SetPenumnbra(float value);
//    void __fastcall SetOwner(TD3Visual * value);
protected:
    LPDIRECT3DRMLIGHT light;
public:
    __declspec(package) __fastcall TD3Light(LIGHT type=ltPoint, TColor color=clWhite, TD3Model* Model=NULL);
    __declspec(package) __fastcall ~TD3Light();

    __property TColor Color  = { read = FColor, write = SetColor };
    __property LIGHT Type  = { read = FType, write = SetType };
    __property float Brightness  = { read = FBrightness, write = SetBrightness };
    __property float HotSpot  = { read = FHotSpot, write = SetUmbra };
    __property float Spot  = { read = FSpot, write = SetPenumnbra };
    __property LPDIRECT3DRMLIGHT Handle  = { read = light };
//    __property TD3Visual * Owner  = { read=FOwner, write = SetOwner };
};
#pragma pack(pop)
//---------------------------------------------------------------------------


#endif
