//---------------------------------------------------------------------------
#ifndef modelsH
#define modelsH
#include <vector.h>
#include <vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "object.h"
#include "export.h"

enum MODELERR {MODELERR_NILD3DRM=-1,MODELERR_NOCREATE=-2,MODELERR_NOLOAD=-3};

//---------------------------------------------------------------------------
#pragma pack(push, 4)

class PACKAGE TD3Model  // base abstract class
{
    friend class TD3Panel;
    friend class TD3Models;
protected:
    AnsiString FName;
    unsigned int FID;
    static unsigned int IDCount;
    int LODCount;
public:
    __fastcall TD3Model() { FID=IDCount++; DetailEnabled=false; };
    virtual __fastcall ~TD3Model() {};

    virtual void __fastcall AttachTo(TD3Visual *Visual) {};
    __property AnsiString Name= { read = FName, write = FName };
    __property unsigned int ID  = { read = FID };
    bool DetailEnabled;
};

class PACKAGE TD3Models : public vector<TD3Model*>      //public TList
{
private:
    unsigned int FCount;
//    void __fastcall SetModel( int __index, TD3Model* value);
//    TD3Model* __fastcall GetModel(int __index);
protected:
public:
    __fastcall TD3Models();
    virtual __fastcall ~TD3Models();
    virtual int __fastcall Add(TD3Model *S);
    virtual int __fastcall Add(AnsiString fname);
    virtual void __fastcall Delete(int Index);
    virtual void __fastcall LoadFromFile(AnsiString fname);
    __property unsigned int Count  = { read = FCount };
//    __property TD3Model* Object[int __index] = { read = GetModel, write = SetModel };
};
#pragma pack(pop)
//---------------------------------------------------------------------------
#endif
