#ifndef __D3DTEXTURE__
#define __D3DTEXTURE__

//-------------------------------------------------------------------------
#include <vcl.h>
#include <list>
#pragma hdrstop

#include "export.h"

class D3DTexture;  //forward declaration
typedef D3DTexture* LPD3DTexture;
typedef std::list<LPD3DTexture> LIST_D3DTexture;  //std::  instead of (using namespace std;)

class PACKAGE D3DTexture {
protected:
        static LIST_D3DTexture list;
	IDirectDrawSurface4 *MemorySurface;  // system memory surface
	IDirectDrawSurface4 *DeviceSurface;  // video memory texture
	IDirectDrawPalette *Palette;
	D3DTEXTUREHANDLE    Handle;
	char cBitmapName[256];
public:
        D3DTexture(char* BitmapName);
        virtual ~D3DTexture();
        D3DTEXTUREHANDLE    GetHandle()    {return Handle;}
	void SetHandle(D3DTEXTUREHANDLE h) { Handle=h; }
        IDirectDrawSurface4* GetSurface()   {return MemorySurface;}
        IDirectDrawPalette* GetPalette()   {return Palette;}

        IDirectDrawSurface4* GetDeviceSurface()   {return DeviceSurface;}
//        BOOL Load(IDirect3DDevice2 *Device, char *BitmapName, int ColorKeyIndex = -1);
//        BOOL LoadMipMap(IDirect3DDevice2 *Device, char *BitmapName[], int NumLevels, int ColorKeyIndex = -1);
        BOOL Load(IDirect3DDevice3 *Device, char *BitmapName, int ColorKeyIndex);
        BOOL LoadMipMap(IDirect3DDevice3 *Device, char *BitmapName[], int NumLevels, int ColorKeyIndex);
	BOOL SetColorKey(int ColorKeyIndex);
        BOOL Copy(HBITMAP Bitmap);
	BOOL Copy(HBITMAP Bitmap, RECT &Src);
	BOOL Copy(HBITMAP Bitmap, LPDIRECTDRAWSURFACE4 CurrentSurface);
//-----bolt (new function from iflera example)------
        BOOL LoadAlpha (IDirect3DDevice3 *Device);
        BOOL CreateDefaultAlpha (void);
//--------------------------------------------------
        BOOL Restore(void);
	char* GetBitmapName() { return cBitmapName; }
	static LIST_D3DTexture& GetList() { return list; }
	static void AfterDeviceCreated(GraphInfo&);
	static void BeforeDeviceDestroyed(GraphInfo&);
    static BOOL AdjustHandleForDevice(IDirect3DDevice3 *Device);
protected:
        void Release(void);
};

#endif //__D3DTEXTURE__
