//---------------------------------------------------------------------------
#ifndef visualH
#define visualH
//---------------------------------------------------------------------------

//#include "d3dunit.h"
#include "models.h"

#define UFO 		"Unknown Visual Object"

//---------------------------------------------------------------------------

class PACKAGE TD3Visual
{
private:
    TD3Visual *FOwner;
    D3DVECTOR FPosition;
    D3DVECTOR FVelocity;
    D3DVECTOR FOrientationDir;
    D3DVECTOR FOrientationUp;
    D3DVECTOR FRotation;
    D3DVECTOR FScale;
    TColor FColor;
    AnsiString FHint;
    AnsiString FName;
    AnsiString FCaption;
    int FTag;
    static TD3Visual * FDefOwner;
    TD3Model *FModel;
    bool FVisible;
    int FLayerID;

    D3DVECTOR __fastcall GetPosition();
    void __fastcall SetOwner(TD3Visual *value);
    void __fastcall SetDefaultOwner(TD3Visual * value);
    TD3Visual * __fastcall GetDefaultOwner();
    virtual void __fastcall SetVelocity(D3DVECTOR value);
    virtual void __fastcall SetPosition(D3DVECTOR value);
    virtual void __fastcall SetOrientationDir(D3DVECTOR value);
    virtual void __fastcall SetOrientationUp(D3DVECTOR value);
    virtual void __fastcall SetRotation(D3DVECTOR value);
    virtual void __fastcall SetScale(D3DVECTOR value);
    virtual void __fastcall SetColor(TColor value);
    virtual void __fastcall SetName(AnsiString value);
    virtual void __fastcall SetVisible(bool value);
protected:
public:
    LPDIRECT3DRMFRAME3  Frame, Axes;			// private??
    static GraphInfo Info;

    __fastcall TD3Visual(TD3Model* MeshBuilder=NULL);
    __fastcall ~TD3Visual();

    __property TD3Visual *Owner  = { read = FOwner, write = SetOwner };
    __property D3DVECTOR Position  = { read = FPosition, write = SetPosition };
    __property D3DVECTOR Velocity  = { read = FVelocity, write = SetVelocity };
    __property D3DVECTOR OrientationDir  = { read = FOrientationDir, write = SetOrientationDir };
    __property D3DVECTOR OrientationUp  = { read = FOrientationUp, write = SetOrientationUp };
    __property D3DVECTOR Rotation  = { read = FRotation, write = SetRotation };
    __property D3DVECTOR Scale  = { read = FScale, write = SetScale };
    __property TColor Color  = { read = FColor, write = SetColor };
    __property AnsiString Hint  = { read = FHint, write = FHint };
    __property AnsiString Name  = { read = FName, write = SetName };
    __property int Tag  = { read = FTag, write = FTag };
    __property AnsiString Caption  = { read = FCaption, write = FCaption };
    __property TD3Visual * DefOwner  = { read = FDefOwner, write = FDefOwner };
    __property TD3Model * Model = { read = FModel, write = FModel };
    __property bool Visible  = { read = FVisible, write = SetVisible };
    __property int LayerID  = { read = FLayerID, write = FLayerID };
};
//---------------------------------------------------------------------------
#endif


