#ifndef D3DUTILS_H
#define D3DUTILS_H
/*
**-----------------------------------------------------------------------------
** Name:    D3DUtils.h
** Purpose: Various D3D utility functions
** Notes:
**
** Copyright (c) 1995 - 1997 by Microsoft, all rights reserved
**-----------------------------------------------------------------------------
*/

//#define D3D_OVERLOADS
#include <d3d.h>
#include <d3dtypes.h>
#pragma hdrstop
#pragma package(smart_init)

extern const float pi;

/*
**-----------------------------------------------------------------------------
** Function Prototypes
**-----------------------------------------------------------------------------
*/

// generic simple matrix routines
//extern "C" {

 /*__declspec(package)*/ D3DMATRIX ZeroMatrix(void);
 /*__declspec(package)*/ D3DMATRIX IdentityMatrix(void);

 /*__declspec(package)*/ D3DMATRIX ProjectionMatrix(const float near_plane, const float far_plane, const float fov);
 /*__declspec(package)*/ D3DMATRIX ViewMatrix(const D3DVECTOR & from, const D3DVECTOR & at,
							const D3DVECTOR & up, const float roll=0.0f);

 /*__declspec(package)*/   D3DMATRIX RotateXMatrix(const float rads);
 /*__declspec(package)*/   D3DMATRIX RotateYMatrix(const float rads);
 /*__declspec(package)*/   D3DMATRIX RotateZMatrix(const float rads);
 /*__declspec(package)*/   D3DMATRIX TranslateMatrix(const float dx, const float dy, const float dz);
 /*__declspec(package)*/   D3DMATRIX TranslateMatrix(const D3DVECTOR & v);
 /*__declspec(package)*/   D3DMATRIX ScaleMatrix(const float size);
 /*__declspec(package)*/   D3DMATRIX ScaleMatrix(const float a, const float b, const float c);
 /*__declspec(package)*/   D3DMATRIX ScaleMatrix(const D3DVECTOR & v);

 /*__declspec(package)*/   D3DMATRIX MatrixMult(const D3DMATRIX & a, const D3DMATRIX & b);
 /*__declspec(package)*/   D3DMATRIX MatrixInverse(const D3DMATRIX & m);
 /*__declspec(package)*/   D3DMATRIX MatrixTranspose(const D3DMATRIX & m);

 /*__declspec(package)*/   D3DVECTOR TransformVector(const D3DVECTOR & v, const D3DMATRIX & m);
 /*__declspec(package)*/   D3DVECTOR TransformNormal(const D3DVECTOR & v, const D3DMATRIX & m);

// Other stuff
 /*__declspec(package)*/   float rnd(void);

//}

#endif // D3DUTILS_H


