//---------------------------------------------------------------------------
#ifndef xmodelH
#define xmodelH

#include "export.h"
#include "models.h"

//---------------------------------------------------------------------------
#pragma pack(push, 4)

enum { LOAD_1stMESH,                    //      
       LOAD_MESHES2ONE,                 //       
       LOAD_ALLMESHES,                  //   
       LOAD_ONETEXTURE=0x10000         //   1  (    )
       };

class PACKAGE TD3XModel: public TD3Model
{
friend class TD3Panorama;
private:
    LPDIRECT3DRMMESHBUILDER3 __fastcall LoadMesh(char *src, int option,
                                    D3DRMLOADTEXTURE3CALLBACK  ldtex, void *arg);
protected:
public:
    TList *Meshes;              //???        
    __fastcall TD3XModel(AnsiString S="", int option=D3DRMLOAD_FROMFILE|D3DRMLOAD_FIRST,
                         D3DRMLOADTEXTURE3CALLBACK  ldtex=NULL, void *arg=NULL );
    virtual __fastcall ~TD3XModel();
    virtual void __fastcall AttachTo(TD3Visual *Visual);
    void __fastcall AddDetailLevel(AnsiString src, int option=D3DRMLOAD_FROMFILE|D3DRMLOAD_FIRST,
                         D3DRMLOADTEXTURE3CALLBACK  ldtex=NULL, void *arg=NULL );
};

class PACKAGE TD3PMModel: public TD3Model
{
private:
protected:
    LPDIRECT3DRMPROGRESSIVEMESH  Mesh;
public:
    __fastcall TD3PMModel(const System::AnsiString S="");
    virtual __fastcall ~TD3PMModel();
    virtual void __fastcall AttachTo(TD3Visual *Visual);
};
#pragma pack(pop)
//---------------------------------------------------------------------------
#endif
