//---------------------------------------------------------------------------
#ifndef cameraH
#define cameraH

#include <list>
#include <vector.h>

#include "object.h"
#include "panorama.h"

//---------------------------------------------------------------------------
#pragma pack(push, 4)

struct DetailLevelParams
{
   float Detail;
   float Front;
};

class PACKAGE TD3LODs : public TList
{
private:
protected:
public:
    __fastcall TD3LODs();
    virtual __fastcall ~TD3LODs();

    virtual int __fastcall Add(float front, float level);
    virtual int __fastcall Add(DetailLevelParams value);
    virtual void __fastcall Delete(int Index);
    virtual void __fastcall Clear();
};

class PACKAGE TD3Camera: public TD3Visual
{
   friend class TD3CameraProp;
private:
    LPDIRECT3DRMFRAME3  OriginFrame;
    float FLens;
    float FFront;
    float FBack;
    TD3LODs *FDetailLevels;
    bool FDetailEnabled;
    void __fastcall SetLens(float value);
    void __fastcall SetFront(float value);
    void __fastcall SetBack(float value);
protected:
public:
    __fastcall TD3Camera(TStereoControl *value);
    virtual void __fastcall Refresh(void);
    virtual __fastcall ~TD3Camera();
    virtual void __fastcall UpdateDetail(D3DVALUE delta);
    __property float Lens  = { read = FLens, write = SetLens };
    __property float Front  = { read = FFront, write = SetFront };
    __property float Back  = { read = FBack, write = SetBack };
    __property TD3LODs *DetailLevels  = { read=FDetailLevels, write=FDetailLevels };
    __property bool DetailEnabled  = { read=FDetailEnabled, write=FDetailEnabled };
};
#pragma pack(pop)
//---------------------------------------------------------------------------
#endif


