//---------------------------------------------------------------------------
#ifndef objectH
#define objectH
//---------------------------------------------------------------------------

#include <vcl.h>
#include <d3drm.h>

//#include "service3d.h"
//#include "models.h"
//#include "triarray.h"

#define UFO 		"Unknown Visual Object"
class PACKAGE TD3Model;   // forvard reference
//---------------------------------------------------------------------------

#pragma pack(push, 4)
class PACKAGE TD3Visual
{
    friend class TStereoControl;
    friend class TD3XModel;
    friend class TD3PMModel;
private:
    TD3Visual *FOwner;
    D3DVECTOR FPosition;
    D3DVECTOR PrevObjPosition,PrevCamPosition;       //   (   ) 
    D3DVECTOR FVelocity;
    D3DVECTOR FDirection;
    D3DVECTOR FUp;
    D3DVECTOR FRotation;
    TColor FColor;
    AnsiString FHint;
    AnsiString FName;
    AnsiString FCaption;
    int FTag;
    static TD3Visual * FDefOwner;
    bool FVisible;
    int FLayerID;
    bool FShowName;
    unsigned int FID;
    static unsigned int IDCount;
    float FDetail;
    D3DVECTOR FCenter;
    D3DVALUE FRadius;
    D3DVECTOR Fpos;
    void __fastcall Setpos(D3DVECTOR value);
    D3DVECTOR __fastcall Getpos();
protected:
    D3DVECTOR FScale;
    LPUNKNOWN ModelHandle;
    TD3Model *FModel;
    virtual void __fastcall SetOwner(TD3Visual *value);
    virtual void __fastcall SetVelocity(D3DVECTOR value);
    virtual void __fastcall SetPosition(D3DVECTOR value);
    virtual void __fastcall SetDirection(D3DVECTOR value);
    virtual void __fastcall SetUp(D3DVECTOR value);
    virtual void __fastcall SetRotation(D3DVECTOR value);
    virtual void __fastcall SetScale(D3DVECTOR value);
    virtual void __fastcall SetColor(TColor value);
    virtual void __fastcall SetVisible(bool value);
    virtual void __fastcall SetName(AnsiString value);
    virtual void __fastcall SetDetail(float value);
    virtual D3DVECTOR __fastcall GetPosition();
    virtual D3DVECTOR __fastcall GetDirection();
    virtual D3DVECTOR __fastcall GetUp();
public:
    LPDIRECT3DRMFRAME3 Frame, Axes;			// private??
    TStereoControl *D3Panel;

//    __fastcall TD3Visual();
    __fastcall TD3Visual(TD3Model* Model=NULL);
//    __fastcall TD3Visual(TD3TriArray* triangles);
    __fastcall ~TD3Visual();
    virtual void __fastcall Refresh(void);
    virtual void __fastcall UpdateDetail(D3DVALUE delta);

    __property TD3Visual *Owner  = { read = FOwner, write = SetOwner };
    __property D3DVECTOR Position  = { read = GetPosition, write = SetPosition };
    __property D3DVECTOR Velocity  = { read = FVelocity, write = SetVelocity };
    __property D3DVECTOR Direction  = { read = GetDirection, write = SetDirection };
    __property D3DVECTOR Up  = { read = GetUp, write = SetUp };
    __property D3DVECTOR Rotation  = { read = FRotation, write = SetRotation };
    __property D3DVECTOR Scale  = { read = FScale, write = SetScale };
    __property TColor Color  = { read = FColor, write = SetColor };
    __property AnsiString Hint  = { read = FHint, write = FHint };
    __property AnsiString Name  = { read = FName, write = SetName };
    __property int Tag  = { read = FTag, write = FTag };
    __property TD3Model * Model = { read = FModel, write = FModel };
    __property bool Visible  = { read = FVisible, write = SetVisible };
    __property int LayerID  = { read = FLayerID, write = FLayerID };
    __property bool ShowName  = { read = FShowName, write = FShowName };
    __property unsigned int ID  = { read = FID };
    __property float Detail  = { read=FDetail, write=SetDetail };
    __property D3DVECTOR Center  = { read=FCenter };
    __property D3DVALUE Radius  = { read=FRadius };
};

#pragma pack(pop)
//---------------------------------------------------------------------------
#endif

