//---------------------------------------------------------------------------
#ifndef objectsH
#define objectsH
//---------------------------------------------------------------------------
#include <vcl.h>
#include <vector.h>
#pragma hdrstop

#include "object.h"
#include "models.h"
#include "panel3d.h"

enum OBJERR {OBJERR_NILD3DRM=-1,OBJERR_NOCREATE=-2,OBJERR_NOLOAD=-3};

//---------------------------------------------------------------------------
//class DELPHICLASS TD3Visuals;

#pragma pack(push, 4)
class PACKAGE TD3Visuals : public vector<TD3Visual *>
{
    friend class TStereoControl;
private:
    LPDIRECT3DRMFRAME  scene_frame;
    TD3Models *models;
protected:
    TStereoControl *D3Panel;
public:
    __fastcall TD3Visuals();
    virtual __fastcall ~TD3Visuals();

    virtual int __fastcall Add(TD3Model* Model=NULL,const System::AnsiString S=UFO);
    virtual int __fastcall Add(TD3Visual *value);
    virtual int __fastcall Add(const System::AnsiString S);
    virtual void __fastcall Delete(int Index);
    virtual void __fastcall LoadFromFile(AnsiString fname);
    __property unsigned int Count  = { read = size};
};

class PACKAGE TD3VisualsList : public vector<TD3Visual *>, public TD3Visual
{
private:
protected:
    virtual void __fastcall SetVelocity(D3DVECTOR value);
    virtual void __fastcall SetPosition(D3DVECTOR value);
    virtual void __fastcall SetDirection(D3DVECTOR value);
    virtual void __fastcall SetUp(D3DVECTOR value);
    virtual void __fastcall SetRotation(D3DVECTOR value);
    virtual void __fastcall SetScale(D3DVECTOR value);
    virtual void __fastcall SetColor(TColor value);
    virtual void __fastcall SetOwner(TD3Visual *value);
    virtual void __fastcall SetVisible(bool value);
    virtual void __fastcall SetName(AnsiString value);
public:
    __fastcall TD3VisualsList();
    virtual __fastcall ~TD3VisualsList();
    virtual int __fastcall Add(TD3Visual *value);
    virtual void __fastcall Delete(int Index);
    __property unsigned int Count  = { read = size};
};
#pragma pack(pop)
//---------------------------------------------------------------------------
#endif

                                
