//---------------------------------------------------------------------------
#ifndef service3dH
#define service3dH

#include <vcl.h>
#include "export.h"
//---------------------------------------------------------------------------
extern "C" {            // exported functions
__declspec(package) void  InitD3D(void);
__declspec(package) void  CloseD3D(void);
__declspec(package) TColor  TColor2RGBA(TColor value, int alfa=0xff);
__declspec(package) D3DCOLORVALUE  TColor2COLORVALUE(TColor value);
__declspec(package) D3DVECTOR  TColor2D3DVECTOR(TColor value);
//__declspec(package) void GetDXVersion (LPDWORD pdwDXVersion, LPDWORD pdwDXPlatform);
__declspec(package) int GetDXVersion (void);
__declspec(package) LPDIRECT3DRM  GetD3DRM (void);
__declspec(package) LPDIRECT3DRM3 GetD3DRM3 (void);
__declspec(package) HRESULT CreateD3DRM(void);
__declspec(package) void DestroyD3DRM(void);
__declspec(package) bool IsProgressiveMesh(char *file);   // test type of x-file
__declspec(package) void Box2Radius(D3DRMBOX *Box, D3DVECTOR *Center, D3DVALUE *Radius);
}

__declspec(package) void ShowErrorMessageBox();
__declspec(package) int RGB2BitMask(DDPIXELFORMAT &PixelFormat, COLORREF src);
__declspec(package) RECT New(TRect src);
__declspec(package) RECT New(int left, int top, int right, int bottom);
__declspec(package) RECT And(TRect rect1, TRect rect2);
__declspec(package) RECT Scale(TRect rect, double sx, double sy);
__declspec(package) int  Sub(TRect src1, TRect src2, RECT *res);
__declspec(package) RECT Move(TRect rect1, int dx, int dy);
__declspec(package) RECT Move(TRect rect1, TPoint &pnt);
__declspec(package) bool IsEqual(TRect rect1, TRect rect2);
__declspec(package) bool IsSizeEqual(TRect rect1, TRect rect2);

// internal functions
BOOL WINAPI DefaultCommon2DHandler(GraphInfo grInfo,D3DRECT ClipRect,int type);

//    ddraw.dll, .. ddraw.lib .   
extern HRESULT WINAPI (*ptrDirectDrawCreate)(GUID FAR *lpGUID,LPDIRECTDRAW FAR *lplpDD,IUnknown FAR *pUnkOuter);
extern HRESULT WINAPI (*ptrDirectDrawCreateClipper)(DWORD dwFlags,LPDIRECTDRAWCLIPPER FAR *lplpDDClipper,IUnknown FAR *pUnkOuter);

//---------------------------------------------------------------------------
#endif
