/*----------------------------------------------------------------------
	Stereo applications constants
	( See examples of using in sendmsg.cpp )
	(c) StereoPixel
-----------------------------------------------------------------------*/

#ifndef stctrlH
#define stctrlH
//----------------------------------------------------------------------------

#define WINDOWCLASS        "TStereoControl"                       // class of main window of stcrtl.exe
#define WINDOWNAME         "eClipse Stereo Driver"                 // name of main window of stcrtl.exe
#define MUTEX_NAME         "MT_StereoControl"                     // name of exclusive mutex of stcrtl.exe
#define DRV_VERSION			1.0

#define LEFTFLIPEVENT      "LEFTFLIPEVENT"
#define RIGHTFLIPEVENT     "RIGHTFLIPEVENT"

enum GLASSESMODES { smDefault, smInterlaced, smOverUnder, smPageFlip, smLineBlanking, smMono};
enum VIDEOMODES   { vmDefault, vmInterlaced, vmOverUnder, vmPageFlip, vmBlueRed, vmLeftRight, 
							/* new insert there */ vmMono};
enum GLASSNUMS    { glLeft, glRight };
enum GLASSESMODEL { gmUnknown, gmEclipse };


// Path and name of configuration in System Registry
#define STCONTROL_ROOTKEY     HKEY_CURRENT_USER
#define STCONTROL_PATHKEY     "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\stctrl.exe"
#define STCONTROL_CONFIGKEY   "SOFTWARE\\StereoPixel\\eClipse Stereo Driver\\"

//   Code for control WM_COPYDATA messages
enum CPDATA_CODE
{ 						 STCTRL_OFF,                                    // deactivate a stereo mode
						 STCTRL_ON,                                     // activate a stereo mode
						 STCTRL_RVRS,                                   // change the polarity of stereo glasses
						 STCTRL_CONFIG,                                 // open the control panel
						 STCTRL_DEFAULT,                                // set default stereo mode
						 STCTRL_IL,                                     // set interlaced stereo mode
						 STCTRL_EMUL,                                   // set line blanking stereo mode
						 STCTRL_PAGEFLIP,                               // set page flipping stereo mode
						 STCTRL_OVERUNDER,                              // set over/under stereo mode
						 STCTRL_GETSTATUS,                              // get current a stereo driver status
						 STCTRL_SETSTATUS,                              // set current a stereo driver status
						 STCTRL_GETPORT,                                // get number of COM-port
						 STCTRL_SETPORT,                                // set number of COM-port
						 STCTRL_EXIT,                                   // shut down the program (stctrl.exe)
						 STCTRL_ATTACH,                                 // attach stereo window
						 STCTRL_DETACH,                                  // detach stereo window
						 STCTRL_OPENALL,                                 // open glasses
						 STCTRL_CLOSEALL                                // close glasses
};
//----------------------------------------------------------------------------
struct StereoConfig
{
		int   Controller, Port, PortNum, Chip, Mode, SupportedModes,
				RefreshRate, Sync, Delay, PrestartInterrupt, PrestartSyncDoubling, WidthSyncDoubling;
		bool  Active, Reversed, FreqTest, QuickSwitch, AutoRun, StereoCursors;
		double DriverVersion;
		int 	Brightness, SF, Version, irsrv[19];
		bool  AutoDetect, UseLineBlanking, brsrv[19];
};
//---------------------------------------------------------------------------
struct  Eclips3Info
{
	BYTE TmPulseHs;   //  
	WORD TmCycleHs;   //  
	BYTE PolarHS;     // 
	WORD NumLines;    // - 
	WORD TmPulseVS;   //  
	WORD TmCycleVS;   //  
	BYTE PolarVS;     // 
	WORD MiddleVS;    //     
							//  Sync Dobling (   )
	BYTE WidthVS;     //    
	WORD BlankVS;     //     
};
//---------------------------------------------------------------------------
struct StereoStatus
{
	int            size;
	int            Active;
	StereoConfig   Config;
	Eclips3Info    Info;
};
//---------------------------------------------------------------------------
#endif

