//---------------------------------------------------------------------------
#ifndef triarrayH
#define triarrayH
//---------------------------------------------------------------------------
#include "sc_uvisual.h"
#include "models.h"
#include "d3matrl.h"

//---------------------------------------------------------------------------
#pragma pack(push, 4)
class PACKAGE TD3TriArray: public Visual, public TD3Model
{
private:
    TStereoControl *d3panel;
    void * FVertices;
    int FVertexCount;
    unsigned short* FIndices;
    int FIndexCount;
    TD3Material FMaterial;
protected:
//    Visual *UserVisual;
    virtual bool Draw(LPDIRECT3DRMDEVICE3 dev,LPDIRECT3DRMVIEWPORT2 view);
public:
    __fastcall TD3TriArray( TStereoControl *value, void* lpvVertices=NULL, int dwVertexCount=0,
                        unsigned short* lpwIndices=NULL, int dwIndexCount=0);
//    virtual __fastcall ~TD3TriArray() {};
    virtual void __fastcall AttachTo(TD3Visual *Visual);
    virtual void __fastcall Refresh();

    __property void * Vertices  = { read = FVertices, write = FVertices };
    __property int VertexCount  = { read = FVertexCount, write = FVertexCount };
    __property unsigned short* Indices  = { read = FIndices, write = FIndices };
    __property int IndexCount  = { read = FIndexCount, write = FIndexCount };
    __property TD3Material Material  = { read = FMaterial, write = FMaterial };
};
#pragma pack(pop)
//---------------------------------------------------------------------------
 #endif
