//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "stereo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Panel3D"
#pragma link "CSPIN"
#pragma link "CGRID"
#pragma link "cgrid"
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
//       
   Application->OnActivate=FormActivate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
//   
   StereoControl1->Stereo->LeftImg->LoadFromFile("left.bmp");
   StereoControl1->Stereo->RightImg->LoadFromFile("right.bmp");

//   ,  
   VideoModeComboBox->Items->Assign(StereoControl1->Stereo->Modes);
   VideoModeComboBox->ItemIndex=5;

//    
   CursorComboBox->Items->AddObject("crArrow",(TObject*)crArrow);
   CursorComboBox->Items->AddObject("crCross",(TObject*)crCross);
   CursorComboBox->Items->AddObject("crIBeam",(TObject*)crIBeam);
	CursorComboBox->Items->AddObject("crSizeNWSE",(TObject*)crSizeNWSE);
	CursorComboBox->Items->AddObject("crHourGlass",(TObject*)crHourGlass);
	CursorComboBox->Items->AddObject("crDrag",(TObject*)crDrag);
	CursorComboBox->ItemIndex=0;
}
//---------------------------------------------------------------------------
//   ,   ..   
void __fastcall TForm1::FormActivate(TObject *Sender)
{
//     
	ActiveCheckBox->Checked=StereoControl1->Glasses->Active;
	ReversedCheckBox->Checked=StereoControl1->Glasses->Reversed;

	char str[111];
	sprintf(str,"Port : COM%d",StereoControl1->Glasses->PortNum);
	PortLabel->Caption=str;
	sprintf(str,"Model : %s",StereoControl1->Glasses->Name);
	ModelLabel->Caption=str;
	sprintf(str,"Video : %s",StereoControl1->Glasses->Chipset);
	VideoLabel->Caption=str;

//   ,  
	GlassesModeComboBox->Items->Assign(StereoControl1->Glasses->Modes);
	GlassesModeComboBox->ItemIndex=GlassesModeComboBox->Items->IndexOfObject((TObject*)StereoControl1->Glasses->Mode);

//       
	static bool first=true;
	if(first)
	{  first=false;
		VideoModeComboBox->OnChange(Sender);   // update
		CursorComboBox->OnChange(Sender);
		BlueRedGrid->OnChange(Sender);
		CursorColorGridChange(Sender);
		LeftDxScrollBar->OnChange(Sender);
		MouseDxScrollBar->OnChange(Sender);
	}

	CheckBox4->Checked=StereoControl1->ShowIcon;
	ScrollBar1->Enabled=(StereoControl1->Stereo->Active && StereoControl1->Stereo->Mode==vmLeftRight);
}
//---------------------------------------------------------------------------
//  
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
		CursorColorGrid->Enabled=false;
		BlueRedGrid->Enabled=false;
		StereoControl1->Enabled=false;
}
//---------------------------------------------------------------------------
//        
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   StereoControl1->Stereo->Flip0();                                             // show changes
}
//---------------------------------------------------------------------------
//     
void __fastcall TForm1::LoadButtonClick(TObject *Sender)
{
  OpenDialog1->Title = "Load Left File";
  if (OpenDialog1->Execute())
  {
	 if (FileExists(OpenDialog1->FileName))
	 {
			StereoControl1->Stereo->Clear(glLeft);
			StereoControl1->Stereo->LeftImg->LoadFromFile(OpenDialog1->FileName);
	  }
  }
  OpenDialog1->Title = "Load Right File";
  if (OpenDialog1->Execute())
  {
	 if (FileExists(OpenDialog1->FileName))
	 {
			StereoControl1->Stereo->Clear(glRight);
			StereoControl1->Stereo->RightImg->LoadFromFile(OpenDialog1->FileName);
	  }
  }
  StereoControl1->Stereo->Update();     //    
}
//---------------------------------------------------------------------------
//   
void __fastcall TForm1::StereoButtonClick(TObject *Sender)
{
  if(StereoButton->Caption=="Stereo")
  {
      StereoButton->Caption="Mono";
      StereoControl1->Stereo->Active=true;
		StereoControl1->Glasses->Active=true;
		ScrollBar1->Enabled=(StereoControl1->Stereo->Mode==vmLeftRight);
  }
  else
  {
		StereoButton->Caption="Stereo";
		StereoControl1->Stereo->Active=false;
		StereoControl1->Glasses->Active=false;
		ScrollBar1->Enabled=false;
  }
}
//---------------------------------------------------------------------------
//  
void __fastcall TForm1::VideoModeComboBoxChange(TObject *Sender)
{
  if(StereoButton->Caption!="Stereo") StereoButtonClick(NULL);    //  
//  
  StereoControl1->Stereo->Mode=(int)VideoModeComboBox->Items->Objects[VideoModeComboBox->ItemIndex];
  StereoControl1->Glasses->SetCompatibleMode(StereoControl1->Stereo->Mode);

//         
  BlueRedGrid->Visible=(StereoControl1->Stereo->Mode==vmBlueRed);
  GlassesModeComboBox->ItemIndex=GlassesModeComboBox->Items->IndexOfObject((TObject*)StereoControl1->Glasses->Mode);
}
//---------------------------------------------------------------------------
//     
void __fastcall TForm1::BlueRedGridChange(TObject *Sender)
{
	if(BlueRedGrid->Enabled)
	{
		StereoControl1->Stereo->ColorLeft=BlueRedGrid->ForegroundColor;
		StereoControl1->Stereo->ColorRight=BlueRedGrid->BackgroundColor;
//   StereoControl1->Stereo->Update();
	}
}
//---------------------------------------------------------------------------
// / 
void __fastcall TForm1::ShowHideButtonClick(TObject *Sender)
{ static bool vis=false;
  if(vis=!vis)
  {
     StereoControl1->Visible=false;
     ShowHideButton->Caption=="Show";
  }
  else
  {
     StereoControl1->Visible=true;
     ShowHideButton->Caption=="Hide";
  }
}
//---------------------------------------------------------------------------
//      (     )
void __fastcall TForm1::LeftDyScrollBarChange(TObject *Sender)
{
  StereoControl1->Stereo->LeftDx=LeftDxScrollBar->Position;
  StereoControl1->Stereo->LeftDy=LeftDyScrollBar->Position;
  StereoControl1->Stereo->RightDx=RightDxScrollBar->Position;
  StereoControl1->Stereo->RightDy=RightDyScrollBar->Position;

//    
//???  if(!StereoControl1->Stereo->Active || StereoControl1->Stereo->Mode!=vmPageFlip)
  StereoControl1->Stereo->Update();
}
//---------------------------------------------------------------------------
// /  
void __fastcall TForm1::ActiveCheckBoxClick(TObject *Sender)
{
   StereoControl1->Glasses->Active=ActiveCheckBox->Checked;
}
//---------------------------------------------------------------------------
//    
void __fastcall TForm1::ReversedCheckBoxClick(TObject *Sender)
{
   StereoControl1->Glasses->Reversed=ReversedCheckBox->Checked;
}
//---------------------------------------------------------------------------
//    
void __fastcall TForm1::GlassesModeComboBoxChange(TObject *Sender)
{
   StereoControl1->Glasses->Mode = (int)GlassesModeComboBox->Items->Objects[GlassesModeComboBox->ItemIndex];
}
//---------------------------------------------------------------------------
//   
void __fastcall TForm1::CursorComboBoxChange(TObject *Sender)
{
   StereoControl1->Cursor=(TCursor)CursorComboBox->Items->Objects[CursorComboBox->ItemIndex];
}
//---------------------------------------------------------------------------
//       
void __fastcall TForm1::CursorColorGridChange(TObject *Sender)
{
	if(CursorColorGrid->Enabled)
	{
		StereoControl1->Stereo->CursorColor=CursorColorGrid->ForegroundColor;
		StereoControl1->Color=CursorColorGrid->BackgroundColor;
	}
}
//---------------------------------------------------------------------------
//       
void __fastcall TForm1::MouseDyScrollBarChange(TObject *Sender)
{
  StereoControl1->Stereo->MouseDx=MouseDxScrollBar->Position;
  StereoControl1->Stereo->MouseDy=MouseDyScrollBar->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::LoadCurcorButtonClick(TObject *Sender)
{ Graphics::TBitmap *Img=new Graphics::TBitmap;

  OpenDialog1->Title = "Load Cursor Bitmap";
  if (OpenDialog1->Execute())
  {
    if (FileExists(OpenDialog1->FileName))
    {
         Img->LoadFromFile(OpenDialog1->FileName);
         StereoControl1->Stereo->SetCursorBitmap(Img->Handle);
     }
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	if(StereoControl1->Enabled)
	{
		char str[111];
		sprintf(str,"Frequency = %d",StereoControl1->Stereo->Frequency);
		FrequencyLabel->Caption=str;
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StereoControl1MouseWheel(TObject *Sender,
	  TShiftState Shift, int WheelDelta, const TPoint &MousePos,
	  bool &Handled)
{
  StereoControl1->Stereo->MouseDx+=WheelDelta/10;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StereoControl1Enter(TObject *Sender)
{
int i=StereoControl1->CanFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StereoControl1Click(TObject *Sender)
{
//   StereoControl1->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
   StereoControl1->Stereo->SaveSizeX=!StereoControl1->Stereo->SaveSizeX;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
	StereoControl1->Stereo->SaveSizeY=!StereoControl1->Stereo->SaveSizeY;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StereoControl1KeyPress(TObject *Sender, char &Key)
{
  Beep(555,555);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
	StereoControl1->Stereo->MonoPage=RadioGroup1->ItemIndex;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox3Click(TObject *Sender)
{
	StereoControl1->Stereo->Reversed=CheckBox3->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  OpenDialog1->Title = "Load Left Icon";
  if (OpenDialog1->Execute() && FileExists(OpenDialog1->FileName))
			StereoControl1->IconLeft->LoadFromFile(OpenDialog1->FileName);
  OpenDialog1->Title = "Load Right Icon";
  if (OpenDialog1->Execute() && FileExists(OpenDialog1->FileName))
			StereoControl1->IconRight->LoadFromFile(OpenDialog1->FileName);
  StereoControl1->Stereo->Update();     //    
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox4Click(TObject *Sender)
{
	StereoControl1->ShowIcon=CheckBox4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
	StereoControl1->Stereo->EyesDx=ScrollBar1->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox5Click(TObject *Sender)
{
	StereoControl1->Glasses->Reversed=!StereoControl1->Glasses->Reversed;
	StereoControl1->Stereo->Update();
}
//---------------------------------------------------------------------------

